
'-------------------------------------------------------------------------------
'Name                     : Softblink.bas
'Copyright                : (c) 2009,   .
'Purpose                  :  
'Processor                : ATTiny13V
'Battery                  : LiOH 3V CR2032
'Romimage                 : 994 dec
'Crystal                  :  RC- 2
'Compiler                 : BASCOM-AVR demo V 1.11.9.5
'-------------------------------------------------------------------------------


   $regfile = "attiny13.dat"                                ' 
   $crystal = 2000000                                       ' 

   Dim Flag1 As Bit                                         ' 
   Dim Flag2 As Bit
   Dim W1 As Byte
   Dim W2 As Word
   Dim K As Byte
   Dim Genp As Word
   Dim I As Byte
   Dim X As Word

   Config Portb.0 = Output                                  '   B
   Config Portb.1 = Output
   Config Portb.2 = Output
   Config Pinb.3 = Input
   Config Pinb.4 = Input

   Config Adc = Single , Prescaler = Auto , Reference = Internal       '  
   Stop Adc                                                 ' 
   Config Timer0 = Pwm , Prescale = 1 , Compare A Pwm = Clear Down
   Stop Timer0                                              '  0

   Config Watchdog = 1024                                   '  watchdog  1 
   Stop Watchdog                                            ' Watchdog


Do


Met1:

   Pwm0a = 0
   Gosub Bat                                                '   
   If Flag2 = 1 Then Goto Batlow                            '    

   Gosub Kod                                                '   Kod
   Stop Timer0
   Reset Portb.0
   If Flag1 = 0 Then Goto Met1                              '    
   Waitms 230                                               ' 230 
   Start Timer0

Met2:

   If X < 6690 Then Incr X                                  ' -   
   If X = 6690 Then                                         '  
   Start Watchdog                                           ' Watchdog
   X = X + 1                                                '    x
   End If

   I = Rnd(215)                                             '   0  214
   I = I + 41                                               '  
   I = I - K                                                '   41  255
   Pwm0a = I                                                '    i

   Gosub Kod                                                '       
   If Flag1 = 0 Then                                        '     
   Waitms 230                                               ' 230 
   X = 0                                                    '  
   Goto Met1                                                '    Met1
   End If

   Gosub Bat                                                '   
   If Flag2 = 1 Then Goto Batlow                            '    

   Genp = Rnd(70)                                           '   0  69
   Genp = Genp + 7                                          '   
   Waitms Genp                                              '       7  76
   Pwm0a = 0                                                '  HL1

   If Flag1 = 0 Then
   Waitms 230
   X = 0
   Goto Met1
   End If

   Genp = Rnd(400)                                          '   0  399
   Genp = Genp + 1                                          '   1
   Waitus Genp                                              '   
   Goto Met2                                                '   Met2


Loop



'-------------------------------------------------------------------------------
'                 
'-------------------------------------------------------------------------------

Kod:

   Stop Timer0                                              ' 
   Delay                                                    '
   Start Adc                                                ' 
   W1 = Getadc(2)                                           '    w1
   Stop Adc                                                 ' 

   If W1 > 135 Then Toggle Flag1                            '    
   Delay                                                    '
   Start Timer0                                             ' 
   Return                                                   '  


'-------------------------------------------------------------------------------
'                
'-------------------------------------------------------------------------------

Bat:

   Start Adc                                                ' 
   W2 = Getadc(3)                                           '    w2
   Stop Adc                                                 ' 

   If W2 <= 1024 Then K = 40                                '     3
   If W2 <= 900 Then K = 35                                 '      2,8
   If W2 <= 790 Then K = 19                                 '       2,5
   If W2 <= 740 Then K = 3

   If W2 <= 670 Then                                        '      2
   K = 0                                                    '     2
   Flag2 = 1                                                '  
   End If                                                   ' 
   Return


'-------------------------------------------------------------------------------
'             
'-------------------------------------------------------------------------------

Batlow:

   Pwm0a = 255
   Waitms 5
   Pwm0a = 0
   Waitms 550
   Goto Batlow

End